import re

def unescape(bufferin):
	bufferout = [""]
	row = -1
	col = 0
	escape = ""
	saved = [0, 0]

	for ch in bufferin:
		if ord(ch) == 27 or len(escape) > 0:
			##########################################################3
			# On ESC
			if chr(27) in [escape, ch]:
				escape = ""
				if ch == "c":
					bufferout = [""]
					row = -1
					col = 0
					saved = [0, 0]
				elif ch == "D":
					row += 1
					if row == 0:
						row = -1
						bufferout.append("")
				elif ch == "M":
					row -= 1
					if row < -len(bufferout):
						bufferout = [""] + bufferout
				elif ch == "7":
					saved = [row + len(bufferout), col]
				elif ch == "8":
					[row, col] = saved
					row -= len(bufferout)
				elif ord(ch) in [27, 91]:
					escape = ch
				continue
			# just after hitting the extended ESC marker
			elif escape == "[":
				escape = ""
			
			if ch in "0123456789;":
				escape += ch
				continue
			elif ch in "Hf":
				opts = escape.split(";")+["",""]
				row = -len(bufferout) + max(0,int("0"+opts[0])-1)
				col = max(0,int("0"+opts[1])-1)
			elif ch in "s":
				saved = [row + len(bufferout), col]
			elif ch in "u":
				[row, col] = saved
				row -= len(bufferout)
			elif ch in "K":
				if escape == "1":
					bufferout[row] = " " * (col+1) + bufferout[row][c+1:]
				elif escape == "2":
					bufferout[row] = ""
				else:
					bufferout[row] = bufferout[row][:col]
			elif ch in "J":
				if len(escape) == 0:
					bufferout = bufferout[:row] + [""]
				else:
					for i in range(row+len(bufferout)+1):
						bufferout[i] = ""
			elif ch in "A":
				row -= max(1,int("0"+escape.split(";")[0]))
				if row <= len(bufferout):
					row = -len(bufferout)
			elif ch in "B":
				row += max(1,int("0"+escape.split(";")[0]))
				while row >= 0:
					bufferout.append("")
					row -= 1
			elif ch in "C":
				col += max(1,int("0"+escape.split(";")[0]))
			elif ch in "D":
				col = max(0, col - max(1,int("0"+escape.split(";")[0])))

			escape = ""
			##########################################################3
			continue

		# control char
		if ch in "\r\n\f\t\b":
			if ch == "\r":
				col = 0
			if ch in "\n\f":
				row += 1
				if row == 0:
					row = -1
					bufferout.append("")
				col = 0
			if ch == "\t":
				col = (col + 8) &~ 7
			if ch == "\b":
				col = max(0, col-1)
			continue

		# keeps to ascii plz kthxbai!
		if ord(ch) not in range(32, 127):
			ch = "?"
		if len(bufferout[row]) < col:
			bufferout[row] += " " * (col-len(bufferout[row]))
		bufferout[row] = bufferout[row][:col] + ch + bufferout[row][col+1:]
		col += 1
	# post processing
	for i in range(len(bufferout)):
		bufferout[i] = re.sub(" *$","",bufferout[i])
		bufferout[i] = sub(r"([A-Z][a-z][a-z] ){2}[ \d]\d \d\d:\d\d:\d\d [A-Z]{3} \d{4}","############################",bufferout[i])
	return "\n".join(bufferout)

if __name__ == "__main__":
	
	# don't touch ascii string
	assert(parse("foo") == "foo")
	
	# concatenate newlines
	assert(parse("foo\nbar\r\nbaz") == "foo\nbar\nbaz")
	
	# ignore font changes
	assert(parse("\033(") == "")
	assert(parse("\033)") == "")
	
	# ignore terminal setup
	assert(parse("\033c") == "")
	assert(parse("\033[7h") == "")
	assert(parse("\033[7l") == "")
	
	#assumes the screen should be cleared
	# cursor home
	#assert(parse("foo\033[H") == "")
	assert(parse("foo\033[Hba") == "bao")
	assert(parse("\033[Hbar") == "bar")
	assert(parse("foo\033[1Hbar") == "bar")
	assert(parse("foo\033[1;1Hbar") == "bar")
	assert(parse("foo\nbar\033[Hbaz") == "baz\nbar")
	assert(parse("foo\nbar\033[H\nbaz") == "foo\nbaz")
	
	#assumes the line should be cleared
	# cursor up
	assert(parse("foo\nbar\033[A") == "foo\nbar")
	assert(parse("foo\nbar\033[1A") == "foo\nbar")
	assert(parse("foo\nbar\n\033[A") == "foo\nbar\n")
	assert(parse("foo\nbar\n\033[2Ab") == "boo\nbar\n")
	
	
	# cursor down
	assert(parse("foo\033[B") == "foo\n")
	assert(parse("foo\033[Bbar") == "foo\n   bar")
	assert(parse("foo\033[2Bbar") == "foo\n\n   bar")
	
	
	# cursor left 
	assert(parse("foo\033[D") == "foo")
	assert(parse("foo\033[Dbar") == "fobar")
	assert(parse("foo\033[2Dbar") == "fbar")
	assert(parse("foo\033[9Dbar") == "bar")
	
	
	# cursor right
	assert(parse("foo\033[C") == "foo")
	assert(parse("foo\033[Cbar") == "foo bar")
	assert(parse("foo\033[2Cbar") == "foo  bar")
	
	# save
	assert(parse("foo\0337bar\0338baz") == "foobaz")
	assert(parse("foo\0337\nbar\0338baz") == "foobaz\nbar")
	
	# xsave
	assert(parse("foo\033[sbar\033[ubaz") == "foobaz")
	assert(parse("foo\033[s\nbar\033[ubaz") == "foobaz\nbar")
	
